#pragma once

// add Win32 headers here
#include <list>

namespace dNet_CPP_List_Test {

  using namespace System;
  using namespace System::ComponentModel;
  using namespace System::Collections;
  using namespace System::Collections::Generic;
  using namespace System::Windows::Forms;
  using namespace System::Data;
  using namespace System::Drawing;
  using namespace System::Diagnostics;

  /// <summary>
  /// Summary for Form1
  ///
  /// WARNING: If you change the name of this class, you will need to change the
  ///          'Resource File Name' property for the managed resource compiler tool
  ///          associated with all .resx files this class depends on.  Otherwise,
  ///          the designers will not be able to interact properly with localized
  ///          resources associated with this form.
  /// </summary>

  public ref class Form1 : public System::Windows::Forms::Form
  {
  public:
    Form1(void)
    {
      InitializeComponent();
      //
      //TODO: Add the constructor code here
      //
    }

    // define a local .NET type class for container tests
    ref class IntClass: public IComparable
    {
    public:
      int I;

      virtual Int32 CompareTo( Object^ obj ) {
        if ( obj->GetType() == IntClass::typeid ) {
          IntClass^ temp = dynamic_cast<IntClass^>(obj);

          return I.CompareTo( temp->I );
        }

        throw gcnew ArgumentException(  "object is not a IntClass" );
      }

      property int Value {
        int get() {
          return I;
        }
        void set( int value ) {
          I = value;
        }
      }

    };

  protected:
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    ~Form1()
    {
      if (components)
      {
        delete components;
      }
    }
  private: System::Windows::Forms::GroupBox^  groupBox1;
  protected: 
  private: System::Windows::Forms::Button^  button2;
  private: System::Windows::Forms::Button^  button1;

  private: System::Windows::Forms::Timer^  timer1;
  private: System::Windows::Forms::TextBox^  memo1;


  private: System::ComponentModel::IContainer^  components;

  protected: 


  private:
    /// <summary>
    /// Required designer variable.
    /// </summary>


#pragma region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    void InitializeComponent(void)
    {
      this->components = (gcnew System::ComponentModel::Container());
      this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
      this->button2 = (gcnew System::Windows::Forms::Button());
      this->button1 = (gcnew System::Windows::Forms::Button());
      this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
      this->memo1 = (gcnew System::Windows::Forms::TextBox());
      this->groupBox1->SuspendLayout();
      this->SuspendLayout();
      // 
      // groupBox1
      // 
      this->groupBox1->Controls->Add(this->button2);
      this->groupBox1->Controls->Add(this->button1);
      this->groupBox1->Location = System::Drawing::Point(13, 13);
      this->groupBox1->Name = L"groupBox1";
      this->groupBox1->Size = System::Drawing::Size(393, 53);
      this->groupBox1->TabIndex = 0;
      this->groupBox1->TabStop = false;
      this->groupBox1->Text = L"Run Tests";
      // 
      // button2
      // 
      this->button2->Location = System::Drawing::Point(88, 20);
      this->button2->Name = L"button2";
      this->button2->Size = System::Drawing::Size(75, 23);
      this->button2->TabIndex = 1;
      this->button2->Text = L"Test STL";
      this->button2->UseVisualStyleBackColor = true;
      this->button2->Click += gcnew System::EventHandler(this, &Form1::button2_Click);
      // 
      // button1
      // 
      this->button1->Location = System::Drawing::Point(7, 20);
      this->button1->Name = L"button1";
      this->button1->Size = System::Drawing::Size(75, 23);
      this->button1->TabIndex = 0;
      this->button1->Text = L"Test .NET";
      this->button1->UseVisualStyleBackColor = true;
      this->button1->Click += gcnew System::EventHandler(this, &Form1::button1_Click);
      // 
      // timer1
      // 
      this->timer1->Tick += gcnew System::EventHandler(this, &Form1::timer1_Tick);
      // 
      // memo1
      // 
      this->memo1->Location = System::Drawing::Point(13, 72);
      this->memo1->Multiline = true;
      this->memo1->Name = L"memo1";
      this->memo1->ReadOnly = true;
      this->memo1->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
      this->memo1->Size = System::Drawing::Size(393, 363);
      this->memo1->TabIndex = 1;
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(418, 447);
      this->Controls->Add(this->memo1);
      this->Controls->Add(this->groupBox1);
      this->Name = L"Form1";
      this->Text = L"dotNET List Tests";
      this->Shown += gcnew System::EventHandler(this, &Form1::Form1_Shown);
      this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
      this->groupBox1->ResumeLayout(false);
      this->ResumeLayout(false);
      this->PerformLayout();

    }
#pragma endregion
  private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
#ifdef _DEBUG
             static const int NT=100;
#else
             static const int NT=400;
#endif
             static const int ND=5000;

             // lists for .NET container tests
             List<IntClass^>^ DataList1=gcnew List<IntClass^>();
             List<IntClass^>^ DataList2=gcnew List<IntClass^>();

             double t;
             Stopwatch ^SW=gcnew Stopwatch;

             for (int i=0;i<ND;i++)
             {
               IntClass^ A=gcnew IntClass;
               A->I=i;
               DataList1->Add(A);
             }

             SW->Reset();
             SW->Start();
             for (int i=0;i<NT;i++)
             {
               for (int j=0;j<DataList1->Count;j++)
               { 
                 IntClass^ A=(IntClass^)DataList1[j];
                 DataList2->Add(A);
               }
               DataList2->Clear();
             }
             SW->Stop();
             t=SW->ElapsedMilliseconds*0.001/NT;
             memo1->Text=memo1->Text+".NET Add-Clear Time: "+t.ToString()+"\r\n";

             SW->Reset();
             SW->Start();
             for (int i=0;i<NT;i++)
             {
               for (int j=0;j<DataList1->Count;j++)
               { 
                 IntClass^ A=(IntClass^)DataList1[j];
                 DataList2->Add(A);
               }
               DataList2->Sort();
               DataList2->Clear();
             }
             SW->Stop();
             t=SW->ElapsedMilliseconds*0.001/NT;
             memo1->Text=memo1->Text+".NET Add-Sort1-Clear Time: "+t.ToString()+"\r\n";

             SW->Reset();
             SW->Start();
             for (int i=0;i<NT;i++)
             {
               for (int j=DataList1->Count-1;j>=0;j--)
               { 
                 IntClass^ A=(IntClass^)DataList1[j];
                 DataList2->Add(A);
               }
               DataList2->Sort();
               DataList2->Clear();
             }
             SW->Stop();
             t=SW->ElapsedMilliseconds*0.001/NT;
             memo1->Text=memo1->Text+".NET Add-Sort2-Clear Time: "+t.ToString()+"\r\n";
           }

  private: System::Void button2_Click(System::Object^  sender, System::EventArgs^  e) {
#ifdef _DEBUG
             static const int NT=1;
#else
             static const int NT=20;
#endif
             static const int ND=5000;

             using namespace std;

             list <int> list1;
             list <int> list2;
             double t;
             Stopwatch ^SW=gcnew Stopwatch;

             for (int i=0;i<ND;i++)
             {
               list1.push_back(ND-i);
             }

             SW->Reset();
             SW->Start();
             for (int i=0;i<NT;i++)
             {
               list<int>::iterator itr;
               for( itr = list1.begin(); itr != list1.end(); itr++)
               {
                 list2.push_back(*itr);
               }
               list2.clear();
             }
             SW->Stop();
             t=SW->ElapsedMilliseconds*0.001/NT;
             memo1->Text=memo1->Text+"STL Add-Clear Time: "+t.ToString()+"\r\n";

             SW->Reset();
             SW->Start();
             for (int i=0;i<NT;i++)
             {
               list<int>::iterator itr;
               for( itr = list1.begin(); itr != list1.end(); itr++)
               {
                 list2.push_back(*itr);
               }
               list2.sort();
               list2.clear();
             }
             SW->Stop();
             t=SW->ElapsedMilliseconds*0.001/NT;
             memo1->Text=memo1->Text+"STL Add-Sort1-Clear Time: "+t.ToString()+"\r\n";

             SW->Reset();
             SW->Start();
             for (int i=0;i<NT;i++)
             {
               list<int>::iterator itr = list1.end();
               while (itr != list1.begin())
               {
                 itr--;
                 list2.push_back(*itr);
               }
               list2.sort();
               list2.clear();
             }
             SW->Stop();
             t=SW->ElapsedMilliseconds*0.001/NT;
             memo1->Text=memo1->Text+"STL Add-Sort2-Clear Time: "+t.ToString()+"\r\n";
           }

  private: System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
           }

  private: System::Void Form1_Shown(System::Object^  sender, System::EventArgs^  e) {
             timer1->Enabled=false;
             memo1->Clear();
           }

  private: System::Void Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
             timer1->Enabled=false;
           }
  };
}

